﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=BLEExample.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnReadData As B4XView
	Private btnDisconnect As B4XView
	Private btnScan As B4XView
	Private lblDeviceStatus As B4XView
	Private lblState As B4XView
	Private pbReadData As B4XLoadingIndicator
	Private clv As CustomListView
	#if B4A
	Private manager As BleManager2
	Private rp As RuntimePermissions
	#else if B4i
	Private manager As BleManager
	#end if
	Private currentStateText As String = "UNKNOWN"
	Private currentState As Int
	Private connected As Boolean = False
	Private ConnectedName As String
	Private ConnectedID As String
	Private ConnectedServices As List
	Private pbScan As B4XLoadingIndicator
	
	'///////////////////////////
	
	Type NameAndMac (Name As String, Mac As String)
	
	' Your Service and Characteristic
	Public SERVICE_UUID As String =          "4fafc201-1fb5-459e-8fcc-c5c9c331914b"
	Public CHARACTERISTIC_UUID As String =   "beb5483e-36e1-4688-b7f5-ea07361b26a8"


	' DEVICE INFORMATION SERVICE
	Public INFO_SERVICE_UUID As String =     "0000180a-0000-1000-8000-00805f9b34fb"
	'         INFORMATION SERVICE characteristics
	Public MODEL_NUMBER As String =          "00002a24-0000-1000-8000-00805f9b34fb"        ' Model Number String
	Public SERIAL_NUMBER As String =         "00002a25-0000-1000-8000-00805f9b34fb"         '     Serial Number String
	Public FIRMWARE_REVISION As String =     "00002a26-0000-1000-8000-00805f9b34fb"         '     Firmware Revision String
	Public HARDWARE_REVISION As String =     "00002a27-0000-1000-8000-00805f9b34fb"         '     Software Revision String
	Public SOFTWARE_REVISION As String =     "00002a28-0000-1000-8000-00805f9b34fb"         '     Software Revision String
	Public MANUFACTURER As String =          "00002a29-0000-1000-8000-00805f9b34fb"
	
	' declare a timer
	Dim scanTimeout As Timer
	
	Public conModelNumber As String = ""
	Public conSerialNumber As String = ""
	Public conFirmwareRevision As String = ""
	Public conHardwareRevision As String = ""
	Public conSoftwareRevision As String = ""
	Public conManufacturerName As String = ""
	
	Private heardDeviceList As List
	Private combineHeardDeviceList As List
	
	
	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True

	scanTimeout.Initialize("scanTimeout", 3000)    ' arbitrary 3 seconds period
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Root = Root1
	Root.LoadLayout("1")
	B4XPages.SetTitle(Me, "BLE Example 1")
	
	'
	heardDeviceList.Initialize
	combineHeardDeviceList.Initialize
	
	'
	manager.Initialize("manager")
	StateChanged
End Sub

Public Sub StateChanged
	lblState.Text = currentStateText
	If connected Then
		lblDeviceStatus.Text = "Connected: " & ConnectedName
	Else
		lblDeviceStatus.Text = "Not connected"
	End If
	btnDisconnect.Enabled = connected
	btnScan.Enabled = Not(connected)
	pbReadData.Hide
	pbScan.Hide
	btnReadData.Enabled = connected
	btnScan.Enabled = (currentState = manager.STATE_POWERED_ON) And connected = False
End Sub

Sub btnScan_Click
	#if B4A
	'Don't forget to add permission to manifest
	Dim Permissions As List
	Dim phone As Phone
	If phone.SdkVersion >= 31 Then
		Permissions = Array("android.permission.BLUETOOTH_SCAN", "android.permission.BLUETOOTH_CONNECT", rp.PERMISSION_ACCESS_FINE_LOCATION)
	Else
		Permissions = Array(rp.PERMISSION_ACCESS_FINE_LOCATION)
	End If
	For Each per As String In Permissions
		rp.CheckAndRequest(per)
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		If Result = False Then
			ToastMessageShow("No permission: " & Permission, True)
			Return
		End If
	Next
	#end if
	pbScan.Show
	StartScan
End Sub

Sub btnDisconnect_Click
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub btnReadData_Click
	pbReadData.Show
	clv.Clear
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

'Sub CreateServiceItem (service As String) As Panel
'	Dim pnl As B4XView = xui.CreatePanel("")
'	pnl.Color = 0xFF808080
'	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 30dip)
'	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
'	lbl.Text = service
'	lbl.SetTextAlignment("CENTER", "CENTER")
'	lbl.Font = xui.CreateDefaultBoldFont(14)
'	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 30dip)
'	Return pnl
'End Sub

'Sub CreateCharacteristicItem(Id As String, Data() As Byte) As Panel
'	Dim pnl As B4XView = xui.CreatePanel("")
'	pnl.SetLayoutAnimated(0, 0, 0, clv.AsView.Width, 40dip)
'	pnl.Color = Colors.White
'	Dim lbl As B4XView = XUIViewsUtils.CreateLabel
'	lbl.Text = Id
'	pnl.AddView(lbl, 0, 0, clv.AsView.Width, 20dip)
'	Dim lbl2 As B4XView = XUIViewsUtils.CreateLabel
'	Try
'		lbl2.Text = BytesToString(Data, 0, Data.Length, "UTF8")
'	Catch
'		Log(LastException)
'		lbl2.Text = "Error reading data as string"
'	End Try
'	lbl2.TextColor = 0xFF909090
'	lbl2.TextSize = 14
'	pnl.AddView(lbl2, 0, 20dip, clv.AsView.Width, 20dip)
'	Return pnl
'End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	StateChanged
End Sub


'Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
'	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
''	If Id = "6D:D4:F2:0C:A4:74" Then
'	ConnectedName = Name
'	manager.StopScan
'	Log("connecting")
'		#if B4A
'	manager.Connect2(Id, False) 'disabling auto connect can make the connection quicker
'	#else if B4I
'	manager.Connect(Id)
'	#end if
''	End If
'End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore

	Dim nm As NameAndMac
	nm.Initialize
	nm.Name = Name
	nm.Mac = Id
		
	'If nm.Name = "yourBLEdevName" Then			' you could filter by BLE "Name"
		heardDeviceList.Add(nm)
		combineHeardDeviceList.Add(nm.Name & " - "&nm.Mac)
	'End If
	
End Sub


'Public Sub StartScan
'	If manager.State <> manager.STATE_POWERED_ON Then
'		Log("Not powered on.")
'	Else
'		manager.Scan2(Null, False)
'	End If
'End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else
		Log("Start Scanning")
		scanTimeout.Enabled = True    ' start this timer
		manager.Scan2( Null, False)    ' don't allow duplicates
	End If
End Sub

'Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
'	pbReadData.Hide
'	clv.Add(CreateServiceItem(ServiceId), "")
'	For Each id As String In Characteristics.Keys
'		clv.Add(CreateCharacteristicItem(id, Characteristics.Get(id)), "")
'	Next
'End Sub


Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	pbReadData.Hide
	
	Log("++++++++++++++++++++++++++++++++++++++++++++++")
	LogColor("Service UID = "&ServiceId, Colors.Cyan)
	LogColor("Characteristic size = "&Characteristics.Size, Colors.yellow)
	
    If ServiceId = INFO_SERVICE_UUID Then                ' check if it is a InfoService UUID
        For Each id As String In Characteristics.Keys
            Dim dataContent() As Byte = Characteristics.Get(id)
            Select id
                Case MODEL_NUMBER
                    conModelNumber = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Model: " & conModelNumber)
                Case SERIAL_NUMBER
                    conSerialNumber = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Serial no.: " & conSerialNumber)
                Case FIRMWARE_REVISION
                    conFirmwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("FW rev: " & conFirmwareRevision)
                Case HARDWARE_REVISION
                    conHardwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("HW rev: " & conHardwareRevision)
                Case SOFTWARE_REVISION
                    conSoftwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("SW rev: " & conSoftwareRevision)
                Case MANUFACTURER
                    conManufacturerName = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Manufacturer: " & conManufacturerName)
            End Select
        Next
    End If
   
    
    If ServiceId = SERVICE_UUID Then                                ' check if it your Service UUID
        If Characteristics.ContainsKey(CHARACTERISTIC_UUID) Then    ' and if Characteristic is the one you're after
            If Characteristics.Getvalueat(0)<>Null Then
                LogColor("Got my Service and Characteristic UUID I was after ...", Colors.blue)
                Dim b() As Byte = Characteristics.Getvalueat(0)     ' here you can get the Characteristic data and an array
                                                                    ' for further processing ...
				LogColor("Characteristic data(0) = "& b(0) , Colors.Cyan) ' just an example ....													
                '...
            End If
        End If
    End If

End Sub







Sub Manager_Disconnected
	LogColor("Disconnected", Colors.red)
	connected = False
	StateChanged
End Sub

Sub Manager_Connected (services As List)
	LogColor("Connected", Colors.Green)
	connected = True
	ConnectedServices = services
	StateChanged
End Sub

'utility to convert short UUIDs to long format on Android
'Private Sub UUID(id As String) As String 'ignore
'#if B4A
'	Return "0000" & id.ToLowerCase & "-0000-1000-8000-00805f9b34fb"
'#else if B4I
'	Return id.ToUpperCase
'#End If
'End Sub



private Sub scanTimeout_Tick
	manager.StopScan                        ' say we heard'em all, can stop scanning for now
	StateChanged
	scanTimeout.Enabled = False             ' and stop this timer
    
	If connected = False Then
		InputListAsync(combineHeardDeviceList, "Choose device to connect", -1, True)    ' show list and choose device
		Wait For InputList_Result (Index As Int)
		If Index <> DialogResponse.CANCEL Then
			
			Dim device As NameAndMac
			device.Initialize
			device = heardDeviceList.Get(Index)
			ConnectedName = device.Name             ' connected BLE device Name
			ConnectedID = device.Mac                ' connected BLE MAC address
			LogColor("connecting to: "&ConnectedName&" | MAC adrs = "&ConnectedID, Colors.Green)
			manager.Connect2(device.Mac, False)     ' here you start connecting to chosen device
			
			' disabling auto connect can make the connection quicker
			ProgressDialogShow2($"Trying to connect to: ${device.Name} (${device.Mac})"$, False)    ' user UI related
			Sleep(3000)            ' some drama
			ProgressDialogHide
		End If
		'
		heardDeviceList.clear
		combineHeardDeviceList.Clear
		'
	End If
End Sub


